//+------------------------------------------------------------------+
//|                                                              rsx |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Navy
#property indicator_width1 2
#property indicator_minimum -5
#property indicator_maximum 105
// #property indicator_level1  50
// #property indicator_levelcolor DimGray

//
//
//
//
//

extern int RsxLength =  5;

extern int Length  = 10;   //    inverse of driving coefficient
extern int Damping =  5;   //    smoothing percent
extern int MaxGap  = 30;   //    maximum week gap ignored (pips)
extern int Shift   =  0;
extern int Price   = PRICE_MEDIAN;



//
//
//
//
//

double rsx[];
double mma[];
double wrkBuffer[][13];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   
  IndicatorBuffers(2);
   SetIndexBuffer(0,rsx);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"RSX");
   SetIndexBuffer(1,mma); SetIndexShift(1,Shift);
   
   IndicatorShortName("Rsx on tmma ("+RsxLength+","+Length+","+Damping+","+MaxGap+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//


double work[][3];
#define _price 0
#define _y1    1
#define _y2    2

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;
  double GapLimit = MaxGap*Point; if (Digits==3 || Digits==5) GapLimit *= 10.0;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars); 
         if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);




   //
   //
   //
   //
   //
   
   double Kg = (3.0)/(2.0+RsxLength); 
   double Hg = 1.0-Kg;
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {


      work[r][_price] = iMA(NULL,0,1,0,MODE_SMA,Price,i);

         double y1 = work[r-1][_y1];
         double y2 = work[r-1][_y2];
         
            if ((High[i]<Low[i+1]) || (Low[i]>High[i+1]))
            {
               double gap = work[r][_price]-work[r-1][_price];
   	      		if (MathAbs(gap)>GapLimit)
                  {
                     y1 = mma[i+1]+gap;
                     y2 = mma[i+2]+gap;
                  }
            }            
            
         double noise  = MathMax(High[i]-Low[i],0.000001);
         double err    = (work[r][_price]-2.0*y1+y2)/noise; 
         double drv    = MathMax(MathMin((1.0/Length)*err*err+(1.0/Length)*MathAbs(err),0.5),0.0);
         double dmp    = MathMax(MathMin((1.0/Length)*MathAbs(y1-y2)/noise + Damping/100.0,1.0),0.0);
         
         //
         //
         //
         //
         //
         
      mma[i]       = y1 + noise*err*drv + (y1-y2)*(1.0-dmp);
      work[r][_y1] = mma[i];
      work[r][_y2] = y1;

      wrkBuffer[r][12] = mma[i];

         if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  

      //
      //
      //
      //
      //
      
      double mom = wrkBuffer[r][12]-wrkBuffer[r-1][12];
      double moa = MathAbs(mom);
      for (int k=0; k<3; k++)
      {
         int kk = k*2;
            wrkBuffer[r][kk+0] = Kg*mom                + Hg*wrkBuffer[r-1][kk+0];
            wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; mom = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
            wrkBuffer[r][kk+6] = Kg*moa                + Hg*wrkBuffer[r-1][kk+6];
            wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; moa = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
      }
      if (moa != 0)
           rsx[i] = MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00); 
      else rsx[i] = 50.0;
   
   
   //
   //
   //
   //
   //



   }
   
   return(0);
}

